searchNodes=[{"doc":"TableRex generates configurable, text-based tables for display","ref":"TableRex.html","title":"TableRex","type":"module"},{"doc":"A shortcut function to render with a one-liner. Sacrifices all customisation for those that just want sane defaults. Returns {:ok, rendered_string} on success and {:error, reason} on failure.","ref":"TableRex.html#quick_render/3","title":"TableRex.quick_render/3","type":"function"},{"doc":"A shortcut function to render with a one-liner. Sacrifices all customisation for those that just want sane defaults. Returns the rendered_string on success and raises RuntimeError on failure.","ref":"TableRex.html#quick_render!/3","title":"TableRex.quick_render!/3","type":"function"},{"doc":"Defines a struct that represents a single table cell, and helper functions. A cell stores both the original data and the string-rendered version, this decision was taken as a tradeoff: this way uses more memory to store the table structure but the renderers gain the ability to get direct access to the string-coerced data rather than having to risk repeated coercion or handle their own storage of the computer values. Fields: raw_value : The un-coerced original value rendered_value : The stringified value for rendering wrapped_lines : A list of 1 or more string values representing the line(s) within the cell to be rendered align : :left : left align text in the cell. :center : center text in the cell. :right : right align text in the cell. nil : align text in cell according to column alignment. color : the ANSI color of the cell. If creating a Cell manually: raw_value is the only required key to enable that Cell to work well with the rest of TableRex. It should be set to a piece of data that can be rendered to string.","ref":"TableRex.Cell.html","title":"TableRex.Cell","type":"module"},{"doc":"","ref":"TableRex.Cell.html#height/1","title":"TableRex.Cell.height/1","type":"function"},{"doc":"Converts the passed value to be a normalised %Cell{} struct. If a non %Cell{} value is passed, this function returns a new %Cell{} struct with: the rendered_value key set to the stringified binary of the value passed in. the raw_value key set to original data passed in. any other options passed are applied over the normal struct defaults, which allows overriding alignment &amp; color. If a %Cell{} is passed in with no rendered_value key, then the raw_value key's value is rendered and saved against it, otherwise the Cell is passed through untouched. This is so that advanced use cases which require direct Cell creation and manipulation are not hindered.","ref":"TableRex.Cell.html#to_cell/1","title":"TableRex.Cell.to_cell/1","type":"function"},{"doc":"","ref":"TableRex.Cell.html#to_cell/2","title":"TableRex.Cell.to_cell/2","type":"function"},{"doc":"","ref":"TableRex.Cell.html#t:t/0","title":"TableRex.Cell.t/0","type":"type"},{"doc":"Defines a struct that represents a column's metadata The align field can be one of :left, :center or :right.","ref":"TableRex.Column.html","title":"TableRex.Column","type":"module"},{"doc":"","ref":"TableRex.Column.html#t:t/0","title":"TableRex.Column.t/0","type":"type"},{"doc":"An Elixir behaviour that defines the API Renderers should conform to, allowing for display output in a variety of formats.","ref":"TableRex.Renderer.html","title":"TableRex.Renderer","type":"behaviour"},{"doc":"Returns a Map of the options and their default values required by the renderer.","ref":"TableRex.Renderer.html#c:default_options/0","title":"TableRex.Renderer.default_options/0","type":"callback"},{"doc":"Renders a passed %TableRex.Table{} struct into a string.","ref":"TableRex.Renderer.html#c:render/2","title":"TableRex.Renderer.render/2","type":"callback"},{"doc":"Return value of the render function.","ref":"TableRex.Renderer.html#t:render_return/0","title":"TableRex.Renderer.render_return/0","type":"type"},{"doc":"Renderer module which handles outputting ASCII-style tables for display.","ref":"TableRex.Renderer.Text.html","title":"TableRex.Renderer.Text","type":"module"},{"doc":"Provides a level of sane defaults for the Text rendering module.","ref":"TableRex.Renderer.Text.html#default_options/0","title":"TableRex.Renderer.Text.default_options/0","type":"function"},{"doc":"Implementation of the TableRex.Renderer behaviour. Available styling options. horizontal_styles controls horizontal separators and can be one of: :all : display separators between and around every row. :header : display outer and header horizontal separators only. :frame : display outer horizontal separators only. :off : display no horizontal separators. vertical_styles controls vertical separators and can be one of: :all : display between and around every column. :frame : display outer vertical separators only. :off : display no vertical separators.","ref":"TableRex.Renderer.Text.html#render/2","title":"TableRex.Renderer.Text.render/2","type":"function"},{"doc":"The data structure for the TableRex.Renderer.Text rendering module, it holds results of style &amp; dimension calculations to be passed down the render pipeline.","ref":"TableRex.Renderer.Text.Meta.html","title":"TableRex.Renderer.Text.Meta","type":"module"},{"doc":"Retrieves the column width at the given column index.","ref":"TableRex.Renderer.Text.Meta.html#col_width/2","title":"TableRex.Renderer.Text.Meta.col_width/2","type":"function"},{"doc":"Retrieves the &quot;inner width&quot; of the table, which is the full width minus any frame.","ref":"TableRex.Renderer.Text.Meta.html#inner_width/1","title":"TableRex.Renderer.Text.Meta.inner_width/1","type":"function"},{"doc":"Retrieves the row width at the given row index.","ref":"TableRex.Renderer.Text.Meta.html#row_height/2","title":"TableRex.Renderer.Text.Meta.row_height/2","type":"function"},{"doc":"A set of functions for working with tables. The Table is represented internally as a struct though the fields are private and must not be accessed directly. Instead, use the functions in this module.","ref":"TableRex.Table.html","title":"TableRex.Table","type":"module"},{"doc":"Adds a single row to the table.","ref":"TableRex.Table.html#add_row/2","title":"TableRex.Table.add_row/2","type":"function"},{"doc":"Adds multiple rows to the table.","ref":"TableRex.Table.html#add_rows/2","title":"TableRex.Table.add_rows/2","type":"function"},{"doc":"Removes column meta for all columns, effectively resetting column meta back to the default options across the board.","ref":"TableRex.Table.html#clear_all_column_meta/1","title":"TableRex.Table.clear_all_column_meta/1","type":"function"},{"doc":"Removes all row data from the table, keeping everything else.","ref":"TableRex.Table.html#clear_rows/1","title":"TableRex.Table.clear_rows/1","type":"function"},{"doc":"Retrieves the value of a column meta option at the specified col_index. If no value has been set, default values are returned.","ref":"TableRex.Table.html#get_column_meta/3","title":"TableRex.Table.get_column_meta/3","type":"function"},{"doc":"Returns a boolean detailing if the passed table has a header row set.","ref":"TableRex.Table.html#has_header?/1","title":"TableRex.Table.has_header?/1","type":"function"},{"doc":"Creates a new blank table. The table created will not be able to be rendered until it has some row data. Examples iex&gt; Table . new % TableRex.Table { }","ref":"TableRex.Table.html#new/0","title":"TableRex.Table.new/0","type":"function"},{"doc":"Creates a new table with an initial set of rows and an optional header and title.","ref":"TableRex.Table.html#new/3","title":"TableRex.Table.new/3","type":"function"},{"doc":"Sets cell level information such as alignment.","ref":"TableRex.Table.html#put_cell_meta/4","title":"TableRex.Table.put_cell_meta/4","type":"function"},{"doc":"Sets column level information such as padding and alignment.","ref":"TableRex.Table.html#put_column_meta/3","title":"TableRex.Table.put_column_meta/3","type":"function"},{"doc":"Sets a list as the optional header row. Set to nil or [] to remove an already set header from renders.","ref":"TableRex.Table.html#put_header/2","title":"TableRex.Table.put_header/2","type":"function"},{"doc":"Sets cell level information for the header cells.","ref":"TableRex.Table.html#put_header_meta/3","title":"TableRex.Table.put_header_meta/3","type":"function"},{"doc":"Sets a string as the optional table title. Set to nil or &quot;&quot; to remove an already set title from renders.","ref":"TableRex.Table.html#put_title/2","title":"TableRex.Table.put_title/2","type":"function"},{"doc":"Renders the current table state to string, ready for display via IO.puts/2 or other means. At least one row must have been added before rendering. Returns {:ok, rendered_string} on success and {:error, reason} on failure.","ref":"TableRex.Table.html#render/2","title":"TableRex.Table.render/2","type":"function"},{"doc":"Renders the current table state to string, ready for display via IO.puts/2 or other means. At least one row must have been added before rendering. Returns the rendered string on success, or raises TableRex.Error on failure.","ref":"TableRex.Table.html#render!/2","title":"TableRex.Table.render!/2","type":"function"},{"doc":"","ref":"TableRex.Table.html#row_colors/2","title":"TableRex.Table.row_colors/2","type":"function"},{"doc":"Sorts the table rows by using the values in a specified column. This is very much a simple sorting function and relies on Elixir's built-in comparison operators &amp; types to cover the basic cases. As each cell retains the original value it was created with, we use that value to sort on as this allows us to sort on many built-in types in the most obvious fashions. Remember that rows are stored internally in reverse order that they will be output in, to allow for fast insertion. Parameters: ` column_index ` : the 0 - indexed column number to sort by ` order ` : supply :desc or :asc for sort direction . Returns a new Table, with sorted rows.","ref":"TableRex.Table.html#sort/3","title":"TableRex.Table.sort/3","type":"function"},{"doc":"","ref":"TableRex.Table.html#t:t/0","title":"TableRex.Table.t/0","type":"type"},{"doc":"","ref":"TableRex.Error.html","title":"TableRex.Error","type":"exception"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"New features: CJK/Unicode character support at the cell level. Non-ascii characters should no longer break rendering. We now have row-level support for colored backgrounds and foregrounds, see some examples . Tables can now have no rows if they wish; that constraint has been relaxed &amp; tables will render fine without any rows (e.g if they just have a header).","ref":"changelog.html#v3-2-0-2023-06-28","title":"Changelog - v3.2.0 (2023-06-28)","type":"extras"},{"doc":"Bugfix: Fixes a multiline text rendering crash when inputs had differing lengths. Thanks to @chulkilee for the fix. No breaking changes.","ref":"changelog.html#v3-1-1-2021-01-30","title":"Changelog - v3.1.1 (2021-01-30)","type":"extras"},{"doc":"Multiline cell support 🎉 Thanks to @rubysolo, TableRex's ASCII-style plain text renderer has gained the ability to render multiline strings without any extra effort on behalf of the calling clients, simply insert your line breaks into your strings and the feature will handle rendering with correct padding, coloring &amp; alignment. No (known) breaking changes.","ref":"changelog.html#v3-1-0-2020-12-31","title":"Changelog - v3.1.0 (2020-12-31)","type":"extras"},{"doc":"No external API changes , but we are dropping support for Elixir v1.7 and below along with Erlang OTP v20 and below and as such the major version number is bumping to appreciate that.","ref":"changelog.html#v3-0-0-2020-04-19","title":"Changelog - v3.0.0 (2020-04-19)","type":"extras"},{"doc":"Version 2 has no external API breaking changes but we are bumping the major version number as the internal data structure of the %Cell{} struct has changed. See note below. New features: sort! Tables can now have a basic sort function which uses Elixir's term ordering to sort your table rows by a specific column in either ascending or descending order. Please see the README for usage; many thanks to everyone at @elixir-poa for this change. you are now free to add your own ANSI color wrappers to text within an inline cell, the extra characters this adds are ignored as part of width calculations and therefore the structure of the table no longer breaks when you do this. Thanks to @geolessel for this change. %Cell{} struct change Previously Cells only stored the string-coerced version of the data you wanted to insert into the table. This was limiting as it meant we could not sort your tables as type information was lost in that process. It also opens up TableRex to many other features now that we keep the original data. The stringified value of a Cell used to be stored at value , it is now stored at rendered_value - with the original being stored at raw_value . To migrate: If you are creating Cells, instead of passing value , pass raw_value . If you are using Cells, it's likely you'll want to use Cell.rendered_value which is now what the removed Cell.value used to be.","ref":"changelog.html#v2-0-0-2018-04-30","title":"Changelog - v2.0.0 (2018-04-30)","type":"extras"},{"doc":"The API seems stable enough, sans major complaints, and has no major open bugs so here is our version 1 release! This release brings only new feature: TableRex has gained the ability to stretch the table width to accommodate long titles, thanks to @matt-harvey. And one breaking change: We are dropping support for Elixir v1.2.x and Erlang 18.x. For the time being, we support the latest 3 minor versions of Elixir, and the latest 2 major versions for Erlang. From now on - as per semver, new breaking changes will increment the major release number, new non-breaking features will increment the minor release number and bug fixes will update the patch number.","ref":"changelog.html#v1-0-0-2017-12-11","title":"Changelog - v1.0.0 (2017-12-11)","type":"extras"},{"doc":"Breaking changes Dropped support for Elixir v1.1.x. We support the latest 3 minor versions, and the latest 2 major versions for Erlang OTP. Other changes: Fixed all compiler warnings resulting from Elixir 1.3 and 1.4 releases.","ref":"changelog.html#v0-10-0-2017-01-14","title":"Changelog - v0.10.0 (2017-01-14)","type":"extras"},{"doc":"Justin G (@theredcoder) has added support for header, column and cell level foreground &amp; background ANSI colouring. Many thanks to Justin.","ref":"changelog.html#v0-9-0-2017-01-14","title":"Changelog - v0.9.0 (2017-01-14)","type":"extras"},{"doc":"Fixed warnings caused by Elixir 1.3's unsafe variable checker.","ref":"changelog.html#v0-8-3-2016-08-12","title":"Changelog - v0.8.3 (2016-08-12)","type":"extras"},{"doc":"Updated some locked development dependencies to reduce warning output during usage.","ref":"changelog.html#v0-8-2-2016-08-12","title":"Changelog - v0.8.2 (2016-08-12)","type":"extras"},{"doc":"Fixed a compilation bug in the new Elixir 1.3. No other changes.","ref":"changelog.html#v0-8-1-2016-06-30","title":"Changelog - v0.8.1 (2016-06-30)","type":"extras"},{"doc":"Breaking changes All Table.set_* functions have been changed to Table.put_* to better reflect their functionality and mimic convention used elsewhere in the Elixir ecosphere.","ref":"changelog.html#v0-8-0-2016-01-19","title":"Changelog - v0.8.0 (2016-01-19)","type":"extras"},{"doc":"Breaking changes The default alignment for columns is now :left rather than :center . This could be a breaking change for your project as if you had not explicitly set columns to be of a certain alignment then your tables will now be output with columns aligned to the left rather than centered as before. This change was made as it's much more likely that a LTR language user is going to want left aligned columns, especially with the multiline cell support which will land soon. If you wish to remain using center-aligned columns then you can manipulate your table struct by calling: Table . set_column_meta ( table , :all , align : :center ) Other changes: Table.set_column_meta and Table.set_header_meta now can also take their column index(es) argument as an enumerable. Previously set_header_meta could not do this and set_column_meta could only be provided a range. Example usage: Table . set_column_meta ( table , 0 , align : :right ) # aligns column 0 to the right. Table . set_column_meta ( table , 0 .. 4 , align : :right ) # aligns column 0 through 4 to the right. Table . set_column_meta ( table , [ 0 , 3 , 5 ] , align : :right ) # aligns column 0, 3 &amp; 5 to the right. Table . set_column_meta ( table , :all , align : :right ) # aligns all current and future columns to the right. Table . set_header_meta ( table , 0 , align : :right ) # aligns header cell 0 to the right. Table . set_header_meta ( table , 0 .. 4 , align : :right ) # aligns header cells 0 through 4 to the right. Table . set_header_meta ( table , [ 0 , 3 , 5 ] , align : :right ) # aligns header cells 0, 3 &amp; 5 to the right.","ref":"changelog.html#v0-7-0-2016-01-09","title":"Changelog - v0.7.0 (2016-01-09)","type":"extras"},{"doc":"No breaking changes Table.new/0 has been supplemented with Table.new/3 which takes rows and an optional header and title . This change was made as when the data is known upfront it was quite verbose doing: Table . new |&gt; Table . add_rows ( rows ) |&gt; Table . set_header ( header ) |&gt; Table . set_title ( title ) |&gt; Table . render The following can now be used instead: Table . new ( rows , header , title ) |&gt; Table . render","ref":"changelog.html#v0-6-0-2016-01-07","title":"Changelog - v0.6.0 (2016-01-07)","type":"extras"},{"doc":"No breaking changes TableRex.Table.set_column_meta now supports applying the column meta to a range of columns as so: TableRex.Table . set_column_meta ( table , 0 .. 3 , align : :right ) This would right-align columns 0 through 3. It is different to using the :all atom as it allows for a subset.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"No breaking changes Added TableRex.Table.set_header_meta/2 which allows a user to set the cell-level attributes (namely, alignment) of a header cell. Header cells can now be aligned individually, separately from the default which is picked up from the column. See issue #3 .","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"No breaking changes Simply an update to bump the version due to an oversight as the generated docs for older version contained documentation for uncommitted files which were not part of the package. This has been remedied as of this version.","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Breaking changes The original TableRex.Table.render!/1 , TableRex.Table.render!/2 and TableRex.Table.render!/3 have been removed and consolidated with TableRex.Table.render!/2 . Choosing a custom renderer module has been moved from a first class argument into the :renderer key of the options argument. What was previously: Table . new |&gt; Table . add_row ( row ) |&gt; Table . render ( CustomRenderer.Module , horizontal_style : :off ) is now: Table . new |&gt; Table . add_row ( row ) |&gt; Table . render ( renderer : CustomRenderer.Module , horizontal_style : :off ) Other changes TableRex.Table.render!/2 has been added as a brother to TableRex.Table.render/2 . It raises TableRex.Error on failure and returns the rendered string directly as opposed to it's brother which returns an Erlang style :ok/:error tuple.","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"First release on hex.pm","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]